// UsbHidSmallDemoCode.cpp : ݿىp̂߂̓_`
//

////////////////////////////////////////////////////////////////////////////////
//  ̎۸тAtUsbHidײ؂̊֐s܂B
//  ײ؊֐^AtUsbHid.ḩ݂̍Ō̕œ܂B
//
//    ȉs܂B
//    1 - AtUsbHid Dllǂݍݐݒ
//    2 - DLLɑ݂AtUsbHid֐ǂݍݐݒ
//    3 - 񋟂鿰 ނłVIDPID̒`pđuJB
//    4 - t܂LEDON/OFF؂ւ
//    5 - UtƑuB
//    6 - DLLJ


#include "stdafx.h"
#include <windows.h>

#include "AtUsbHid.h"

///////////////////////////////////////////
// USB HIDűIDƐiID
#define VID 0x03EB
#define PID_1 0x2011
#define PID_2 0x2013

int main(int argc, char* argv[])
{
	// ɏՕǂݍ
	unsigned char sbuffer[256];

	// LEDݒɎgpɏՕ
	unsigned char	leds[9];

	// AtUsbHid.dll
	HINSTANCE hLib = NULL;  // XUSB HID DLLւ

	printf("Atmel USB HID Library Test Program\n\n\n\n");


	///////////////////////////////////////////////////////////////////////////
	// AtUsbHidײ؂̖Iȓǂݍݐݒ
	printf(">>> Loading USB HID Dll.\n");

	hLib = LoadLibrary(AT_USB_HID_DLL);
	if (hLib != NULL) {
		printf(">>> USB HID Dll loaded\n");
	}
	else {
		if(GetLastError()==ERROR_MOD_NOT_FOUND) {
			printf("Error: Could not find the Atmel USB HID Dll.\n");
			printf("       Please update the PATH variable.\n");
		}
		else {
			printf("Error: While opening Dll.\n");
		}
		return 1;
	}

	///////////////////////////////////////////////////////////////////////////
	// USB HIDײ؊֐ڽ擾
	printf(">>> Loading all Dll functions.\n");
	if (loadFuncPointers(hLib)) {
		printf(">>> All function of the Dll has been loaded\n");
	}
	else {
		printf("Error: Could not find load function of the Dll.\n");
		return 1;
	}

	///////////////////////////////////////////////////////////////////////////
	// XUSB HIDuJB
	printf(">>> Opening USB HID device with Vendor ID= 0x%04X and Product ID=0x%04X or ID=0x%04X.\n", VID, PID_1,PID_2);

	if (DYNCALL(findHidDevice)(VID, PID_2)) {
		printf(">>> USB HID device  VID=0x%04X, PID=0x%04X opened.\n", VID, PID_1);
	}
	else {
		switch(GetLastError()) {
			case ERROR_USB_DEVICE_NOT_FOUND :
				printf("Error: Could not open the device.\n");
				break;
			case ERROR_USB_DEVICE_NO_CAPABILITIES:
				printf("Error: Could not get USB device capabilities.\n");
				break;
			default:
				printf("Error: While opening device.\n");
				break;
		}
		if (DYNCALL(findHidDevice)(VID, PID_2)) {
			printf(">>> USB HID device  VID=0x%04X, PID=0x%04X opened.\n", VID, PID_2);
		}
		else {
			switch(GetLastError()) {
				case ERROR_USB_DEVICE_NOT_FOUND :
					printf("Error: Could not open the device.\n");
					break;
				case ERROR_USB_DEVICE_NO_CAPABILITIES:
					printf("Error: Could not get USB device capabilities.\n");
					break;
				default:
					printf("Error: While opening device.\n");
					break;
			}
		}
	}

	// ڑꂽuɂĂ̂̏\

	printf(">>> USB HID Input   Buffer size is %dByte.\n",DYNCALL(getInputReportLength()));
	printf(">>> USB HID Output  Buffer size is %dByte.\n",DYNCALL(getOutputReportLength()));
	printf(">>> USB HID Feature Buffer size is %dByte.\n",DYNCALL(getFeatureReportLength()));

	// tĂԁA
	while(DYNCALL(readData(sbuffer))==0)
	{
			// LED1ONɐ؂ւ
			leds[0]='1';
			leds[1]='1';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED2ONɐ؂ւ
			leds[0]='1';
			leds[1]='2';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED3ONɐ؂ւ
			leds[0]='1';
			leds[1]='3';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED4ONɐ؂ւ
			leds[0]='1';
			leds[1]='4';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED1OFFɐ؂ւ
			leds[0]='0';
			leds[1]='1';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED2OFFɐ؂ւ
			leds[0]='0';
			leds[1]='2';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED3OFFɐ؂ւ
			leds[0]='0';
			leds[1]='3';
			DYNCALL(writeData)(leds);
			Sleep(100);

			// LED4OFFɐ؂ւ
			leds[0]='0';
			leds[1]='4';
			DYNCALL(writeData)(leds);
			Sleep(100);
	}

	if(sbuffer[0]==1) {
		printf(">>> Button as been pressed, leave the application\n");
	}
	else {
		printf(">>> Button as been released\n");
	}

	// XUSB HIDuB
	DYNCALL(closeDevice)();
	printf(">>> USB HID device VID=0x%04X closed.\n", VID);

	// DLLJOɕׂگނ҂B
	Sleep(1000);
	FreeLibrary(hLib);
	printf(">>> Please press a key to exit");
	getchar();

	return 0;
}
